[3/9,v2] Add has-spdx-header.sh script

Message ID 87h7u8lsla.fsf@redhat.com
State Committed
Headers
Series Relicensing Libabigail to Apache 2.0 + LLVM Exception |

Commit Message

Dodji Seketeli July 15, 2020, 3:13 p.m. UTC
  Add a script to detect if a file has a SPDX header and what the
advertised license is.

	   * relicensing-scripts/has-spdx-header.sh: New script.

Signed-off-by: Dodji Seketeli <dodji@redhat.com>
Signed-off-by: Giuliano Procida <gprocida@google.com>
Signed-off-by: Matthias Maennich <maennich@google.com>
---
 relicensing-scripts/has-spdx-header.sh | 105 +++++++++++++++++++++++++++++++++
 1 file changed, 105 insertions(+)
 create mode 100755 relicensing-scripts/has-spdx-header.sh
  

Comments

Jonathan Wakely July 16, 2020, 10:26 a.m. UTC | #1
On 15/07/20 17:13 +0200, Dodji Seketeli wrote:
>Add a script to detect if a file has a SPDX header and what the
>advertised license is.
>
>	   * relicensing-scripts/has-spdx-header.sh: New script.
>
>Signed-off-by: Dodji Seketeli <dodji@redhat.com>
>Signed-off-by: Giuliano Procida <gprocida@google.com>
>Signed-off-by: Matthias Maennich <maennich@google.com>

Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
  
Dodji Seketeli July 16, 2020, 4:20 p.m. UTC | #2
Jonathan Wakely <jwakely@redhat.com> writes:

> On 15/07/20 17:13 +0200, Dodji Seketeli wrote:
>>Add a script to detect if a file has a SPDX header and what the
>>advertised license is.
>>
>>	   * relicensing-scripts/has-spdx-header.sh: New script.
>>
>>Signed-off-by: Dodji Seketeli <dodji@redhat.com>
>>Signed-off-by: Giuliano Procida <gprocida@google.com>
>>Signed-off-by: Matthias Maennich <maennich@google.com>
>
> Signed-off-by: Jonathan Wakely <jwakely@redhat.com>

Applied, thanks.  It's going to show up in the v3 set of patches.  Until
then you can see this in the relicensing branch that can be browsed at
https://sourceware.org/git/?p=libabigail.git;a=shortlog;h=refs/heads/relicensing.

Cheers,
  

Patch

diff --git a/relicensing-scripts/has-spdx-header.sh b/relicensing-scripts/has-spdx-header.sh
new file mode 100755
index 0000000..d4b7e08
--- /dev/null
+++ b/relicensing-scripts/has-spdx-header.sh
@@ -0,0 +1,105 @@ 
+#!/bin/sh
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+# Author: Dodji Seketeli <dodji@redhat.com>
+
+file=
+prog=$0
+display_file_name=
+be_quiet=
+show_no_spdx=
+
+display_usage()
+{
+    echo "$prog: [options] file"
+    echo "  where options can be:"
+    echo "   -h|--help		display this help"
+    echo "   -f|--file		prefix output with file name"
+    echo "   -q|--quiet		emit no output if no license was found"
+    echo "   --show-no-spdx	show file name if it has no spdx header"
+}
+
+emit_output_no_license()
+{
+    if test x$show_no_spdx != x; then
+	echo $display_file_name
+    elif test x$be_quiet = x; then
+	if test "x$display_file_name" = x; then
+	    echo "NO-LICENSE"
+	else
+	    echo "$display_file_name: NO-LICENSE"
+	fi
+    fi
+
+    exit 1
+}
+
+emit_output_with_license()
+{
+    license=$1
+    if test x$show_no_spdx != x; then
+	:
+    elif test "x$display_file_name" = x; then
+	echo "$license"
+    else
+	echo "$display_file_name: $license"
+    fi
+    exit 0
+}
+
+main()
+{
+    license=$(head --lines=5 $file | sed -n -E "s/^.*(SPDX-License-Identifier:)[ 	]*([^*/]+).*$/\2/p")
+
+    if test "x$license" = x; then
+	emit_output_no_license
+    else
+	emit_output_with_license "$license"
+    fi
+}
+
+while test $# -ge 1
+do
+    case "$1" in
+	-h|--help)
+	    display_usage
+	    exit 0
+	    ;;
+
+	-f|--file)
+	    if test x$2 = x; then
+		>&2 display_usage
+		exit 1
+	    fi
+	    display_file_name=$2
+	    shift
+	    ;;
+
+	-q|--quiet)
+	    be_quiet=yes
+	    shift
+	    ;;
+
+	--show-no-spdx)
+	    if test x$2 = x; then
+		>&2 display_usage
+		exit 1
+	    fi
+	    show_no_spdx=yes
+	    display_file_name=$2
+	    shift
+	    ;;
+
+	*)
+	    break
+	    ;;
+    esac
+done
+
+if test $# -lt 1; then
+    >&2 display_usage
+    exit 1
+fi
+
+file=$1
+
+main